#!/bin/sh

# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

ANTLR3_JAR_DIR=$(readlink -f ../../../develop-tools/antlr3)

CLASSPATH=$ANTLR3_JAR_DIR/antlr-3.1.1.jar:$ANTLR3_JAR_DIR/antlrworks-1.2.3.jar

echo "ANTLR grammar file =" $1
echo "Java CLASSPATH     =" $CLASSPATH
echo ""

java -classpath $CLASSPATH org.antlr.Tool ExprScript.g
