# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""
################################################################################
IPC constants
################################################################################

TODO

"""

#
# Sanetd
#

SANETD_INFO_QUEUE   = 'sanetd-info-%s'

SANETD_CLT_QUEUE    = 'sanetd-ctl'

SANETD_EVENTS_QUEUE = 'sanetd-events'

SANETD_STATE_QUEUE  = 'sanetd-state'

SANETD_CONFIG_QUEUE = 'sanetd-config'

#
# Autocond
#
AUTOCONF_QUEUE = 'autoconfd-data'

AUTOCONF_DISCOVERYDATA_QUEUE = 'autoconfd-discovery-data'

AUTOCONF_CTL_QUEUE           = 'autoconfd-clt'


#
# SNMP TRAPS
#
SNMPTRAP_DATA_QUEUE = 'sanetd-traps-data'

#
# GENERIC
#
def TEMP_REPLY_QUEUE(queue_id):
	return 'temp-%s' % (queue_id) 



AGENT_NETINFOHELPER = 'netinfohelper'

#
# AGENTS
#
def AGENT_QUEUE(agent_id):
	return 'sanet-agent-%s' % (agent_id)

def AGENT_QUEUE_SUBSYSTEM(agent_id, subid):
	return AGENT_QUEUE('%s-%s' % (agent_id, subid))
	
def AGENT_CTL_QUEUE(agent_id):
	return AGENT_QUEUE_SUBSYSTEM(agent_id, 'ctl')

def AGENT_CHECKER_QUEUE(agent_id):
	return AGENT_QUEUE_SUBSYSTEM(agent_id, 'checker')

def AGENT_NETINFOHELPER_QUEUE(agent_id):
	return AGENT_QUEUE_SUBSYSTEM(agent_id, AGENT_NETINFOHELPER)
	
def AGENT_TEMP_REPLY_QUEUE(agent_id):
	return 'temp-agent-%s' % (agent_id) 
