#!/bin/bash

BASE=$1
INSTALL_DIR=$2

echo "Updating install directory value '$INSTALL_DIR' in files inside $BASE"

MUST_EDIT_FILES=$(rgrep -l -e '^SANET_REMOTE_INSTALL_DIR=' $BASE | grep -v .svn | grep -v Binary)

for file in $MUST_EDIT_FILES
do
	echo "Fixing file" $file

	sed -i -e "s|^SANET_REMOTE_INSTALL_DIR.*|SANET_REMOTE_INSTALL_DIR='$INSTALL_DIR'|" $file
done
