
from sanet_common.mailing import load_mail_handler_class

from conf import get_configuration


def init_mail_handler_from_conf(config=None):
	
	if config is None:
		config = get_configuration()
		
	return load_mail_handler_class(config.SANETD_MAIL_HANDLER)


def init_mail_sender_from_conf(logger, config=None):
	
	if config is None:
		config = get_configuration()
		
	handler_class = init_mail_handler_from_conf(config)
	
	return handler_class(logger, config.SANETD_MAIL_HANDLER_PARAMS)
