#!/bin/bash

COLOR_GREEN='\e[0;32m'
COLOR_RED_BOLD='\e[1;31m'
COLOR_OFF='\e[0m'

OUTPUT=$(sanet-manage 2>&1)
RET=$?
if [ "$RET" != "0" ]; then
	echo -en "$COLOR_RED_BOLD"
	echo "*** Configuration file contains errors. Check traceback below ***"
	echo -en "$COLOR_OFF"
	echo "--------------------------------------------------------------------------------"
	echo "$OUTPUT"
	exit -1
else
	echo -en "$COLOR_GREEN"
	echo "Configuration file seems correct"
	echo -en "$COLOR_OFF"
fi
