
function init()
{
	//document.write( gettext("Javascript for web interface working") );
}

function makeid()
{
	var text = "";
	var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

	for( var i=0; i < 5; i++ )
		text += possible.charAt(Math.floor(Math.random() * possible.length));

	return text;
}

function s4() 
{
	return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
}

function guid() {
	return s4() + s4() +  s4() +  s4() + s4() + s4() + s4() + s4();
}
			


function mustache_parse_template(template, context, delims) 
{
	//
	// A volte e' comodo usare dei template per mustache usando dei delimitatori
	// diversi da quelli standard di mustachejs : {{ , }} 
	//
	var old_delims = Mustache.tags ;
	
	Mustache.tags = delims;
	
	var t = Mustache.to_html(template, context)
	
	Mustache.tags = old_delims;
	
	return t;
}

function untag_elementid(element_uuid, tag_uuid, success_callback)
{
	//
	// Domanda: dov'e' definito il codice per gestire le richieste ajax?
	//
	var SANET_AJAX_RESPONSE_SUCCESS = 'success';
	var SANET_AJAX_RESPONSE_ERROR   = 'error';

	//
	// L'accesso al NameSpase globale di sanet si fa cosi'?
	//
	var delete_url = NS.base_prefix + 'web/tags/untag_elementid?uuid=' + element_uuid + '&tag_uuid=' + tag_uuid;

	//
	// Domanda: Le richieste adjax dirette come vengono gestite negli altri widget?
	//
	jQuery.get(delete_url, function (response_data) {

		//
		// Domanda: il parsing della response come viene gestito negli altri widget?
		//
		var response = $.parseJSON(response_data);

		if (response['status'] == SANET_AJAX_RESPONSE_SUCCESS) {
			//
			// Domanda: come faccio a visualizzare un dialog box  uguale per tutta l'interfaccia grafica?
			//
			//$('[data-sid='+element_uuid+']').remove();

			if (success_callback != undefined) 
				success_callback()
			else
				alert("Element untagged");
			
            
		}
		else if (response['status'] == SANET_AJAX_RESPONSE_ERROR) {
			alert(response['info']);
		}
		else {
			alert("MALFORMED RESPONSE: " + response_data)
		}
	});
}

function delete_tag(element_uuid, success_callback)
{
	//
	// Domanda: dov'e' definito il codice per gestire le richieste ajax?
	//
	var SANET_AJAX_RESPONSE_SUCCESS = 'success';
	var SANET_AJAX_RESPONSE_ERROR   = 'error';

	//
	// L'accesso al NameSpase globale di sanet si fa cosi'?
	//
	var delete_url = NS.base_prefix + 'web/tags/remove?id=' + element_uuid;

	//
	// Domanda: Le richieste adjax dirette come vengono gestite negli altri widget?
	//
	jQuery.get(delete_url, function (response_data) {

		//
		// Domanda: il parsing della response come viene gestito negli altri widget?
		//
		var response = $.parseJSON(response_data);

		if (response['status'] == SANET_AJAX_RESPONSE_SUCCESS) {
			//
			// Domanda: come faccio a visualizzare un dialog box  uguale per tutta l'interfaccia grafica?
			//
			//$('[data-sid='+element_uuid+']').remove();
			
			if (success_callback != undefined) 
				success_callback()
			else
				alert("Tag deleted");
		}
		else if (response['status'] == SANET_AJAX_RESPONSE_ERROR) {
			alert(response['info']);
		}
		else {
			alert("MALFORMED RESPONSE: " + response_data)
		}
	});
}
