



function _generic_form(DIALOG, FORM_ID, FORM_BUTTON, title, url, success_callback)
{

	jQuery.get(url, function (response_data) {

		$(DIALOG).dialog('close');
		$(DIALOG).dialog('destroy');
		$(DIALOG).empty();
		
		$(DIALOG).append(response_data);
		
		function init_form()
		{
			var options = {
				target: DIALOG,
				beforeSend: function() {
				},
				complete:function(){
					init_form();
				},
				success : function (result_data, result) {
					return success_callback(result_data, result);
				},
			};		
			$(FORM_ID).ajaxForm(options);
			
			//$(document).on('click', FORM_BUTTON, function() {
			$(FORM_BUTTON).click(function() {
				$(FORM_ID).submit();
				return false;
			});
		}

		init_form();

		
		$(DIALOG).dialog({
			title: title,
			autoOpen: false,
			width: "auto",
			height: "auto",
			buttons: {
			}
			,
			close: function() {
			}
		});
		$(DIALOG).dialog('open');
	});	

	return false;
}



/* **********************************************************************
 * 
 * 
 * **********************************************************************
 */
var UPDATESETTINGS_FORM  = "#update_settings_form";

function init_update_settings_form()
{
	var options = {
		target  : '#update_settings_container',
		beforeSend: function() {
		},
		complete:function(){
		},
		success : function (result_data, result) {
			
			NS.ShowFadeMessage("Updated");
						//var remote = $('#wid_wprioritylevels').data('premote');
						//NS.delay_dl(remote);
			
		}
	};		
	$(UPDATESETTINGS_FORM).ajaxForm(options);
}

jQuery.change_password_form_submit = function()
{
	init_update_settings_form();
	$(UPDATESETTINGS_FORM).submit();
}

$(document).on('click', '#confirm_update_settings', function() {
	init_update_settings_form();
	$(UPDATESETTINGS_FORM).submit();
});

/* **********************************************************************
 * 
 * 
 * **********************************************************************
 */

function remove_priority_level(label, url)
{
	$.ajax({
		type: 'POST',
		url: url,
		async: false,
		success: function(data){
			$('#row_level_' + label).remove();
		}
	});
}

/* **********************************************************************
 * 
 * 
 * **********************************************************************
 */

var ICON_UPDATE_FORM  = "#icon_update_form";

function init_icon_update_form()
{
	var options = {
		//target  : '#update_icon_container',
		//dataType: 'json',
		
		beforeSend: function() {
		},
		complete:function() {
		},
		error: function() {
			//alert('errore');
		},
		success : function (json) {
			$('#current_site_icon').attr('src', json.data.icon_url);
		}
	};

	$(ICON_UPDATE_FORM).ajaxForm(options);
}

jQuery.icon_update_form_submit = function()
{
	//init_icon_update_form();
	$(ICON_UPDATE_FORM).submit();
}


$(document).on('click', '#confirm_icon_upload', function() {
	init_icon_update_form();
	$(ICON_UPDATE_FORM).submit();
});



/* **********************************************************************
 * 
 * 
 * **********************************************************************
 */


var ICON_ADD_FORM  = "#icon_add_form";

function init_icon_add_form()
{
	var options = {
		beforeSend: function() {
			//alert('beforesend');
		},
		complete:function(){
			//alert('complete');
		},
		success : function (result_data, result) {
			//alert(result_data);
		}
	};		
	$(ICON_ADD_FORM).ajaxForm(options);
}
jQuery.icon_add_form_submit = function()
{
	$(ICON_ADD_FORM).submit();
}

$(document).on('click', '#confirm_icon_add', function() {
	init_icon_add_form();
	$(ICON_ADD_FORM).submit();
});



function remove_icon(icon_name, url)
{
	$.ajax({
		type: 'POST',
		url: url,
		async: false,
		success: function(data){
			$('#row_icon_' + icon_name).remove();
		}
	});
}







/* **********************************************************************
 * 
 * 
 * **********************************************************************
 */


function new_priority_label_dialog(url_new_priority_label)
{
	
	var DIALOG      = '#global_dialog_placeholder';
	var FORM_ID     = '#add_priority_level_form';
	var FORM_BUTTON = '#confirm_add';
	
	jQuery.get(url_new_priority_label, function (response_data) {

		$(DIALOG).dialog('close');
		$(DIALOG).dialog('destroy');
		$(DIALOG).empty();
		
		$(DIALOG).append(response_data);
		
		function init_form()
		{
			var options = {
				target: DIALOG,
				beforeSend: function() {
				},
				complete:function(){
					init_form();
				},
				success : function (result_data, result) {
					
					if (result_data == "OK") {
						//NS.ShowFadeMessage("Updated");
						//var remote = $('#wid_wprioritylevels').data('premote');
						//NS.delay_dl(remote);
						
						
						$(DIALOG).dialog('close');
						$(DIALOG).dialog('destroy');
					}
				},
			};		
			$(FORM_ID).ajaxForm(options);
			
			$(document).on('click', FORM_BUTTON, function() {
				$(FORM_ID).submit();
				return false;
			});
		}

		init_form();

		
		$(DIALOG).dialog({
			title: gettext( "Add new priority range"),
			autoOpen: false,
			width: "auto",
			height: "auto",
			buttons: {
			}
			,
			close: function() {
			}
		});
		$(DIALOG).dialog('open');
	});	
}


/* **********************************************************************
 * 
 * 
 * **********************************************************************
 */


function new_agent_dialog(url_new_priority_label)
{
	return _agent_form(url_new_priority_label)
}

function edit_agent(uuid, url_new_priority_label)
{
	return _agent_form(url_new_priority_label)
}
function _agent_form(url) 
{
	var DIALOG            = '#global_dialog_placeholder';
	var AGENT_FORM_ID     = '#add_agent_form';
	var AGENT_FORM_BUTTON = '#confirm_add';
	
	
	jQuery.get(url, function (response_data) {

		$(DIALOG).dialog('close');
		$(DIALOG).dialog('destroy');
		$(DIALOG).empty();
		
		$(DIALOG).append(response_data);
		
		function init_form()
		{
			var options = {
				target: DIALOG,
				beforeSend: function() {
				},
				complete:function(){
					init_form();
				},
				success : function (result_data, result) {
					
					if (result_data == "OK") {
						$(DIALOG).dialog('close');
						$(DIALOG).dialog('destroy');
					}
				},
			};		
			$(AGENT_FORM_ID).ajaxForm(options);
			
			$(document).on('click', AGENT_FORM_BUTTON, function() {
				$(AGENT_FORM_ID).submit();
				return false;
			});
		}

		init_form();

		
		$(DIALOG).dialog({
			title: gettext( "Agent"),
			autoOpen: false,
			width: "auto",
			height: "auto",
			buttons: {
			}
			,
			close: function() {
			}
		});
		$(DIALOG).dialog('open');
	});	
}

function remove_agent(agent_id, url)
{
	$.ajax({
		type   : 'POST',
		url    : url,
		async  : false,
		success: function(data){
			$('#row_agent_' + agent_id).remove();
		}
	});
}

/* **********************************************************************
 * 
 * 
 * **********************************************************************
 */

function config_get_nodes_csv(export_url)
{
	window.open(export_url + '?fields=name,effective_ip&order_by=name', 'SANET3 Nodes CSV file');
}

/* **********************************************************************
 * 
 * 
 * **********************************************************************
 */
 
 
function refresh_autoconf_widgets()
{
	var widget = $('#wid_discoverednodes_list');
	

	var show_all = $('#show_all')[0].checked; 
	var payload = {"show_all": show_all};



	wcore.blockAutorefresh.call(widget);
	
	wcore.update.call(widget, payload, true);
}

function refresh_autoconf_subnet_widgets()
{
	var remote = $('#wid_discoverysubnets').data('premote');	
	NS.delay_dl(remote);
}


function _block_widget_refresh_from_button(button)
{
	var button = $(button);
	var widget = $(button.closest('.widget')[0]);
	console.log(widget.attr('id'));
	wcore.blockAutorefresh.call(widget);	
}



function autoconf_select_all(button_id)
{
	_block_widget_refresh_from_button(button_id);
	
	if (button_id == undefined) {
		$( "input.discoveredelement[type=checkbox]" ).each(function(i, e){ 
			e.checked = ! e.checked;
		});
	}
	else {
		$('#'+button_id +" input.discoveredelement[type=checkbox]" ).each(function(i, e){ 
			e.checked = ! e.checked;
		});
	}
	
}


function autoconf_set_autodiscovery(button, url)
{
	_block_widget_refresh_from_button(button);
	
	return _send_uuids(url);
}
 
function autoconf_check_selected(button, url)
{
	_block_widget_refresh_from_button(button);
	
	return _send_uuids(url);
}


function autoconf_remove_elements(button, url)
{
	if (confirm("Are you sure?")) {
		return _send_uuids(url);
	}
}

function autoconf_show_all_elements(button, url)
{
	var widget = $('#wid_discoverednodes_list');
	
	//var wstate = wcore.getWstate.call(widget);
	
	var show_all = $(button)[0].checked; //.prop( "checked" );
	
	var payload = {"show_all": show_all};

	wcore.async.lock.call(widget);
	
	wcore.update.call(widget, payload, true);
}



function autoconf_refresh(button)
{
	return refresh_autoconf_widgets();
}

function _send_uuids(url, classname)
{
	if (classname == undefined)
		classname = "discoveredelement";
		
	var all_unchecked = Array();
	
	$( "input."+classname+"[type=checkbox]:checked" ).each(function(){ 
		all_unchecked.push($(this).attr('id')) 
	});
	
	$.ajax({
		type   : 'POST',
		data   : { 'uuids': all_unchecked.join() },
		url    : url,
		async  : false,
		success: function(data){

			if (classname == "discoveredelement")
				refresh_autoconf_widgets();
			else {
				refresh_autoconf_subnet_widgets();
			}
		}
	});
}

function _send_uuids_to_url(url, uids, success_callback)
{
	$.ajax({
		type   : 'POST',
		data   : { 'uuids': uids },
		url    : url,
		async  : false,
		success: function(data){
			success_callback(data);
		}
	});
}


function autoconf_expand_node(button, uuid, url)
{
	_block_widget_refresh_from_button(button);

	var ID         = '#' + uuid + "_subs";
	var ID_CONTENT = '#' + uuid + "_subs_content";
	
	var show_all = $('#show_all')[0].checked ? 1 : 0;


	if ($(ID).is(":visible")) {
		
		$(ID_CONTENT).empty();
		
		$(ID).css('display', 'none');
	} 
	else {

		$.ajax({
			type   : 'POST',
			
			data: {
				'show_all': show_all,
			},
			
			url    : url,
			async  : false,
			success: function(data){
				
				$(ID_CONTENT).empty();
				$(ID_CONTENT).append(data);
				
				$(ID).css('display', 'table-row');
				
			}
		});		
		
	}

	return false;
}

function autoconf_create_monitored_element(uuid, url)
{
	/*$.ajax({
		type   : 'POST',
		url    : url,
		async  : false,
		success: function(data){
			//alert(data);
			//$(ID).empty();
			//$(ID).append(data);
			//$(ID).css('display', 'initial');
		}
	});
	*/
	
	//_generic_form('prova', url);

	var AUTOCONF_DIALOG        = '#global_dialog_placeholder';
	var AUTOCONF_FORM_ID       = '#form';
	var AUTOCONF_SUBMIT_BUTTON = '#submit';	
	
	return _generic_form(AUTOCONF_DIALOG, AUTOCONF_FORM_ID, AUTOCONF_SUBMIT_BUTTON, 
		"Create new monitored element", 
		url,
		function (result_data, result) {
			if (result_data == "OK") {
				$(AUTOCONF_DIALOG).dialog('close');
				$(AUTOCONF_DIALOG).dialog('destroy');
			}
		}
	);
}


function autoconf_link_monitored_element(uuid, url)
{
	var AUTOCONF_DIALOG        = '#global_dialog_placeholder';
	var AUTOCONF_FORM_ID       = '#form';
	var AUTOCONF_SUBMIT_BUTTON = '#submit';	
	
	return _generic_form(AUTOCONF_DIALOG, AUTOCONF_FORM_ID, AUTOCONF_SUBMIT_BUTTON, 
		"Link to monitored element", 
		url,
		function (result_data, result) {
			if (result_data == "OK") {
				$(AUTOCONF_DIALOG).dialog('close');
				$(AUTOCONF_DIALOG).dialog('destroy');
			}
		}
	);	

}

function autoconf_unlink_monitored_element(uuid, url)
{
	$.ajax({
		type   : 'POST',
		url    : url,
		async  : false,
		success: function(data){
			/*
			 * $(ID_CONTENT).empty();
			$(ID_CONTENT).append(data);
			
			$(ID).css('display', 'table-row');
			*/
			refresh_autoconf_widgets();
		}
	});
}



function autoconf_edit_element(uuid, url)
{
	/*$.ajax({
		type   : 'POST',
		url    : url,
		async  : false,
		success: function(data){
			//alert(data);
			//$(ID).empty();
			//$(ID).append(data);
			//$(ID).css('display', 'initial');
		}
	});
	*/
	
	var AUTOCONF_DIALOG        = '#global_dialog_placeholder';
	var AUTOCONF_FORM_ID       = '#form';
	var AUTOCONF_SUBMIT_BUTTON = '#submit';
	
	return _generic_form(AUTOCONF_DIALOG, AUTOCONF_FORM_ID, AUTOCONF_SUBMIT_BUTTON, 
		"Edit", 
		url,
		function (result_data, result) {
			if (result_data == "OK") {
				$(AUTOCONF_DIALOG).dialog('close');
				$(AUTOCONF_DIALOG).dialog('destroy');
			}
		}
	);
}








function autoconf_remove_subnets(url)
{
	if (confirm("Are you sure?")) {
		return _send_uuids(url, "discoverysubnet");
	}
}



function autoconf_change_subnet_action(url, id)
{
	$.ajax({
		type   : 'POST',
		data   : { 'id': id },
		url    : url,
		async  : false,
		success: function(data){
			refresh_autoconf_subnet_widgets();
		}
	});	
}


function autoconf_add_subnets(url)
{
	var AUTOCONF_SUBNET_DIALOG        = '#global_dialog_placeholder';
	var AUTOCONF_SUBNET_FORM_ID       = '#form';
	var AUTOCONF_SUBNET_SUBMIT_BUTTON = '#submit';
	
	return _generic_form(AUTOCONF_SUBNET_DIALOG, AUTOCONF_SUBNET_FORM_ID, AUTOCONF_SUBNET_SUBMIT_BUTTON, "Subnet", url, function (result_data, result) {
					
					if (result_data == "OK") {
						$(AUTOCONF_SUBNET_DIALOG).dialog('close');
						$(AUTOCONF_SUBNET_DIALOG).dialog('destroy');
						
						refresh_entables_widgets();
					}
				}
	);	
	
}

/* **********************************************************************
 * 
 * 
 * **********************************************************************
 */

function refresh_entables_widgets()
{
	var widget_id = 'wid_entables';
	var remote = $('#'+widget_id).data('premote');
	
	NS.delay_dl(remote);
}

function _entables_form(title, url)
{
	var DIALOG        = '#global_dialog_placeholder';
	var FORM_ID       = '#form';
	var SUBMIT_BUTTON = '#submit';
	
	return _generic_form(DIALOG, FORM_ID, SUBMIT_BUTTON, title, url, function (result_data, result) {
		if (result_data == "OK") {
			$(DIALOG).dialog('close');
			$(DIALOG).dialog('destroy');
			refresh_entables_widgets();
		}
	});
}



function entables_add_new_chain(url)
{
	return _entables_form(gettext( "Add new chain"), url);
}

function entables_add_rule(url)
{
	return _entables_form(gettext( "Add new rule"), url);
}

function entables_del_chain(url)
{
	$.ajax({
		type   : 'POST',
		url    : url,
		async  : false,
		success: function(result_data){
			if (result_data == "OK") {
				refresh_entables_widgets();
			}		
		}
	});
}

function entables_del_rule(url)
{
	$.ajax({
		type   : 'POST',
		url    : url,
		async  : false,
		success: function(result_data){
			if (result_data == "OK") {
				refresh_entables_widgets();
			}		
		}
	});
}


function entables_toggle_active(url)
{
	$.ajax({
		type   : 'POST',
		url    : url,
		async  : false,
		success: function(result_data){
			if (result_data == "OK") {
				refresh_entables_widgets();
			}		
		}
	});
}

function entables_toggle_stop(url)
{
	$.ajax({
		type   : 'POST',
		url    : url,
		async  : false,
		success: function(result_data){
			if (result_data == "OK") {
				refresh_entables_widgets();
			}		
		}
	});
}

function entables_add_match(url)
{
	return _entables_form(gettext( "Add match"), url);
}



function entables_del_match(url)
{
	$.ajax({
		type   : 'POST',
		url    : url,
		async  : false,
		success: function(result_data){
			if (result_data == "OK") {
				refresh_entables_widgets();
				
			}
		}
	});
}

function entables_config_target(url)
{
	return _entables_form(gettext( "Configure"), url);
}






/* **********************************************************************
 * 
 * 
 * **********************************************************************
 */
 
function set_tree_group_perm(html_control)
{
	var o = $(html_control);
	
	$.ajax({
		type   : 'POST',
		url    : o.attr("url"),
		data : {
			group_id: o.attr("group"),
			tree_id : o.attr("tree"),
			perm    : o.val()
		},
		async  : false,
		success: function(result_data){
			if (result_data == "ok") {
				NS.ShowFadeMessage("Updated");
				refresh_entables_widgets();
			}
			else {
				NS.ShowFadeMessage("Error");
			}
		}
	});
}



/* **********************************************************************
 * 
 * 
 * **********************************************************************
 */



var TEST_EXPR_FORM = '#test_expr_form';


function init_test_expr_form()
{
	var parent =$(TEST_EXPR_FORM).parent();
	
	var options = {
		target  : parent,
		beforeSend: function() {
		},
		complete:function(){
		},
		success : function (result_data, result) {
		}
	};		
	
	$(TEST_EXPR_FORM).ajaxForm(options);
}


jQuery.test_expr_form_submit = function()
{
	init_test_expr_form();
	
	$(TEST_EXPR_FORM).submit();
	
	return false;
}

