
function refresh_tenants()
{
	NS.refresh_widget('wtenants', null, true);
}

function refresh_users()
{
	NS.refresh_widget('wusers', null, true);
}

function refresh_groups()
{
	NS.refresh_widget('wgroups', null, true);
}

function refresh_usersgroups()
{
	NS.refresh_widget('wusersgroups', null, true);
}

function refresh_tenantsgroups()
{
	NS.refresh_widget('wtenantsgroups', null, true);
}

function configuration_refresh_capabilities()
{
	var tenantid = $('#tenant_capabilities').val();

	NS.refresh_widget('wcapabilities', {'selected_tenant':tenantid}, true)
}

function configuration_remove_user(object, userid)
{
	var url = object.getAttribute('url');

	url = url + '?' + 'userid=' + userid;

	$.ajax({
		type: 'POST',
		url: url,
		async: false,
		success: function(data){
			
			NS.refresh();
			//refresh_users();
			//refresh_usersgroups();
		}
	});
}

function configuration_remove_group(object, userid)
{
	var url = object.getAttribute('url');

	url = url + '?' + 'groupid=' + userid;

	$.ajax({
		type: 'POST',
		url: url,
		async: false,
		success: function(data) {

			NS.refresh();

			//refresh_groups();
			//refresh_usersgroups();
			//refresh_tenantsgroups();
			//configuration_refresh_capabilities();
		}
	});
}


function configuration_usersgroups_toggle_association(object, userid, groupid)
{
	var url = object.getAttribute('url');

	url = url + '?' + 'userid=' + userid + '&' + 'groupid=' + groupid;

	$.ajax({
		type: 'POST',
		url: url,
		async: false,
		success: function(data){
			
						
			dati = JSON.parse(data);

			if(dati['data']['added'] == true)
			{
				icon = $(object).find('li')
				icon.addClass("icon-circle").removeClass("icon-minus");
				icon.css("color", "green");
			}
			
			if(dati['data']['added'] == false)
			{
				icon = $(object).find('li')
				icon.addClass("icon-minus").removeClass("icon-circle");
				icon.css("color", "red");
			}
			
			//NS.refresh();

			//refresh_usersgroups();
		}
	});	
}

function configuration_tenantsgroups_toggle_association(object, tenantid, groupid)
{
	var url = object.getAttribute('url');

	url = url + '?' + 'tenantid=' + tenantid + '&' + 'groupid=' + groupid;

	$.ajax({
		type: 'POST',
		url: url,
		async: false,
		success: function(data){
			
			dati = JSON.parse(data);

			if(dati['data']['added'] == true)
			{
				icon = $(object).find('li')
				icon.addClass("icon-circle").removeClass("icon-minus");
				icon.css("color", "green");
			}
			
			if(dati['data']['added'] == false)
			{
				icon = $(object).find('li')
				icon.addClass("icon-minus").removeClass("icon-circle");
				icon.css("color", "red");
			}

			//NS.refresh();

			//refresh_tenantsgroups();
		}
	});

}

function configuration_groups_toggle_capability(object, capability, groupid)
{
	var url = object.getAttribute('url');
	
	var tenantid = $('#tenant_capabilities').val();

	url = url + '?' + 'capabilityid=' +capability + '&' + 'groupid=' + groupid + '&' + 'tenantid=' + tenantid;

	$.ajax({
		type: 'POST',
		url: url,
		async: false,
		success: function(data) {
			
			dati = JSON.parse(data);

			if(dati['data']['added'] == 'true')
			{
				icon = $(object).find('li')
				icon.addClass("icon-circle").removeClass("icon-minus");
				icon.css("color", "green");
			}
			
			if(dati['data']['added'] == 'false')
			{
				icon = $(object).find('li')
				icon.addClass("icon-minus").removeClass("icon-circle");
				icon.css("color", "red");
			}

			//NS.refresh_widget('wcapabilities', {'selected_tenant':tenantid}, true)
		}
	});

}













function _generic_form3(DIALOG, FORM_ID, FORM_BUTTON2, title, url, success_callback)
{

	jQuery.get(url, function (response_data) {

		$(DIALOG).dialog('close');
		$(DIALOG).dialog('destroy');
		
		$(FORM_ID).empty();
		
		$(DIALOG).empty();
		$(DIALOG).append(response_data);
		
		function init_form()
		{
			var options = {
				target: DIALOG,
				beforeSend: function() {
				},
				complete:function(){
					init_form();
				},
				success : function (result_data, result) {
					
					return success_callback(result_data, result);
					
					//if (result_data == "OK") {
					//	$(DIALOG).dialog('close');
					//	$(DIALOG).dialog('destroy');
					//	
					//	refresh_entables_widgets();
					//}
				},
			};		
			$(FORM_ID).ajaxForm(options);
			
			//$(document).on('click', FORM_BUTTON2, function() {
			$(FORM_BUTTON2).click('click', function() {
				$(FORM_ID).submit();
				return false;
			});
		}

		init_form();

		
		$(DIALOG).dialog({
			title: title,
			autoOpen: false,
			width: "auto",
			height: "auto",
			buttons: {
			}
			,
			close: function() {
			}
		});
		$(DIALOG).dialog('open');

		$(DIALOG).show();
	});

	return false;
}

function configuration_add_user(url)
{
	var CONFIGURATION_DIALOG        = '#global_dialog_placeholder';
	//var CONFIGURATION_DIALOG        = '#create_user_container';
	var CONFIGURATION_FORM_ID       = '#form';
	var CONFIGURATION_SUBMIT_BUTTON = '#submit';	
	
	return _generic_form3(CONFIGURATION_DIALOG, CONFIGURATION_FORM_ID, CONFIGURATION_SUBMIT_BUTTON, 
		"Create user", 
		url,
		function (result_data, result) {
			if (result_data == "OK") {
				$(CONFIGURATION_DIALOG).dialog('close');
				$(CONFIGURATION_DIALOG).dialog('destroy');

				refresh_users();
				refresh_usersgroups();
				refresh_tenantsgroups();
			}
		}
	);		
}

function configuration_update_user(url)
{
	var CONFIGURATION_DIALOG        = '#global_dialog_placeholder';
	//var CONFIGURATION_DIALOG        = '#create_user_container';
	var CONFIGURATION_FORM_ID       = '#form';
	var CONFIGURATION_SUBMIT_BUTTON = '#submit';	
	
	return _generic_form3(CONFIGURATION_DIALOG, CONFIGURATION_FORM_ID, CONFIGURATION_SUBMIT_BUTTON, 
		"Update user", 
		url,
		function (result_data, result) {
			if (result_data == "OK") {
				$(CONFIGURATION_DIALOG).dialog('close');
				$(CONFIGURATION_DIALOG).dialog('destroy');

				refresh_users();
				refresh_usersgroups();
				refresh_tenantsgroups();
			}
		}
	);		
}

function configuration_add_group(url)
{
	var CONFIGURATION_GROUP_DIALOG        = '#global_dialog_placeholder';
	var CONFIGURATION_GROUP_FORM_ID       = '#form';
	var CONFIGURATION_GROUP_SUBMIT_BUTTON = '#submit';
	
	return _generic_form3(CONFIGURATION_GROUP_DIALOG, CONFIGURATION_GROUP_FORM_ID, CONFIGURATION_GROUP_SUBMIT_BUTTON, 
		"New group", 
		url,
		function (result_data, result) {
			if (result_data == "OK") {
				$(CONFIGURATION_GROUP_DIALOG).dialog('close');
				$(CONFIGURATION_GROUP_DIALOG).dialog('destroy');

				refresh_groups();
				refresh_usersgroups();
				refresh_tenantsgroups();
				configuration_refresh_capabilities();
			}
		}
	);		
}
