"""
tag_clean_dead_elementtag
========================================================================================

TODO

"""

import os
import json
import time
import cPickle
import sys

#from optparse import make_option

#from django.core.management.base import BaseCommand
from django.db import connection

from core.api.base import *
#from core.models import DataGroup, MonitoredElement

from core.management.commands import SanetInternalCommand, TenantBasedCommand

#from tags.models import TagTree, ElementTag
#from tags.models import TAG_ELEMENTTYPE_DATAGROUP
#from tags.models import TAG_ELEMENTTYPE_CONDITION

from tags.api.state2 import *

from sanet_common.termutils import *

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(SanetInternalCommand, TenantBasedCommand):

	help = "** INTERNAL COMMAND. DO NOT USE **"

	sanet_internal = True

	#option_list = TenantBasedCommand.option_list + (
	#)

	def handle(self, **options):#, tag_id=None, **options):

		tenant = self.get_tenant(options)

		tenant.db_set_current_schema()

		cursor = connection.cursor()
		
		query = """
delete 
  from tags_elementtag et
 where et.uuid in (
         select et_uuid
           from (
                 select   et_c.uuid         et_uuid
                        , et_c.mtime        et_mtime
                        , et_c.elementtype  et_elementtype
                        , et_c.elementid    et_elementid
                        , x.uuid            x_uuid
                   from tags_elementtag et_c  left join  condition           x      on (et_c.elementid = x.uuid)
                  where et_c.elementtype = 'condition'
                ) t
          where x_uuid is null
         union
         select et_uuid
           from (
                 select   et_c.uuid         et_uuid
                        , et_c.mtime        et_mtime
                        , et_c.elementtype  et_elementtype
                        , et_c.elementid    et_elementid
                        , x.uuid            x_uuid
                   from tags_elementtag et_c  left join  datagroup           x      on (et_c.elementid = x.uuid)
                  where et_c.elementtype = 'datagroup'
                ) t
          where x_uuid is null
         union
         select et_uuid
           from (
                 select   et_c.uuid         et_uuid
                        , et_c.mtime        et_mtime
                        , et_c.elementtype  et_elementtype
                        , et_c.elementid    et_elementid
                        , x.uuid            x_uuid
                   from tags_elementtag et_c  left join  timegraph           x      on (et_c.elementid = x.uuid)
                  where et_c.elementtype = 'timegraph'
                ) t
          where x_uuid is null
         union
         select et_uuid
           from (
                 select   et_c.uuid         et_uuid
                        , et_c.mtime        et_mtime
                        , et_c.elementtype  et_elementtype
                        , et_c.elementid    et_elementid
                        , x.uuid            x_uuid
                   from tags_elementtag et_c  left join  monitoredelement    x      on (et_c.elementid = x.uuid)
                  where et_c.elementtype in ('node', 'interface', 'storage', 'service', 'device')
                ) t
          where x_uuid is null
)
;
		"""
		
		cursor.execute(query)

		if cursor.rowcount > 0:
			print "Deleted:", cursor.rowcount

