
from core.models import TimeGraph
from tags.models import *

from webui.api.Data import BaseDataSet

from webui.views import render_new_timegraph

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

class DataSet(BaseDataSet):

	def __init__(self, id):
		super(DataSet, self).__init__(id)

	def get_data(self, options):

		element = self.fetch_entity(options)
		
		el = TimeGraph.objects.filter(element=element, primary=True)[0:1]
		if len(el) > 0:
			el = el[0]
			
			dataset = render_new_timegraph([el], el.uuid, options.get('tenant'),  False, "line", int(options.get('from_ts')), int(options.get('to_ts')), True)
		else:
			dataset = {}

		return {
			'dataset': dataset
		}
