
from django.db import models

from core.models import TenantDependentModel


# Esempio di tabella globale
class DashboardElement(models.Model):

	name  = models.TextField()
	class Meta:
		db_table = "dashboardelement"

# Esempio di tabella specifica del tenant
class WebConfigOption(TenantDependentModel):
	name  = models.TextField()
	value = models.TextField()
	class Meta:
		db_table = "webconfigoption"
