# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""
################################################################################
Process FORK utilities
################################################################################

TODO

"""

import os
import sys

#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

# PYTHON FORK BUG WORK AROUND http://bugs.python.org/issue6380

def __fork():
	
	#print "__myfork"
	imp.acquire_lock()
	try:
		#print "forking"
		return _os_fork()
	finally:
		imp.release_lock()
		
		
python_version = sys.version_info
if python_version[0] == 2 and ((python_version[1] >= 7) or (python_version[1] == 6 and python_version[2] >= 5)):
	# This trick shouldn't be necessary anymore since python 2.6.5 - Issue #7242 - The import lock is now reinitialized after fork.
	pass
else:
	#print "redefining os.fork (%s)" % (sys.version_info, )
	try:
		_os_fork
	except NameError:
		_os_fork = os.fork
		os.fork = __fork

#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

def safe_fork():
	"""
	TODO
	"""

	os.fork()
