# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""
################################################################################
Process Lock utilities
################################################################################

TODO

"""

import os
import fcntl

#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

class FileLocker(object):
	"""
	TODO
	"""

	def __init__(self, file_path):
		"""
		TODO
		"""

		super(FileLocker, self).__init__()

		self.path = file_path

		self.lockf = None

	def lock(self):
		"""
		TODO
		"""

		if self.lockf:
			return True

		try:
			self.lockf = open(self.path, 'w+')
			fcntl.lockf(self.lockf, fcntl.LOCK_EX | fcntl.LOCK_NB)

			self.lockf.truncate()
			self.lockf.write('%d\n' % os.getpid())

			return True

		except IOError:
			return False

	def unlock(self):
		"""
		TODO
		"""

		if not self.lockf:
			return 

		fcntl.lockf(self.lockf, fcntl.LOCK_UN)

		self.lockf = None

