import os
import sys

BASE_DIR = os.path.abspath(os.path.join(os.path.dirname(os.path.abspath(__file__)), "..", ".." ))
sys.path.insert(0, BASE_DIR )

print BASE_DIR

#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

from remotepoller.logic import read_config_file

from remotepoller.checker.agent import launch_remote_checker_from_settings

#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

if __name__ == "__main__":
	
	if len(sys.argv) != 2:
		print "usage: %s <agent config file>" % (sys.argv[0])
		sys.exit(-1)
	
	config_file = sys.argv[1]
	
	print "Reading config file: ", config_file
		
	settings = read_config_file(config_file)

	print "Launcing..."
	
	launch_remote_checker_from_settings(settings)
	
	# never returns
	
	sys.exit(0)
