
# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""

####################################################################################
MAIN
####################################################################################

TODO

"""

import os
import sys

BASE_DIR = os.path.abspath(os.path.join(os.path.dirname(os.path.abspath(__file__)), "..", ".." ))
sys.path.insert(0, BASE_DIR )

print BASE_DIR 

#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

from remotepoller.logic import read_config_file

from remotepoller.discovery.agent import launch_remote_discovery_from_settings

#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

if __name__ == "__main__":
	
	if len(sys.argv) != 2:
		print "usage: %s <agent config file>" % (sys.argv[0])
		sys.exit(-1)
	
	config_file = sys.argv[1]
	
	print "Reading config file: ", config_file
		
	settings = read_config_file(config_file)

	print "Launcing..."
	
	launch_remote_discovery_from_settings(settings)
	
	# never returns
	
	sys.exit(0)
