# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.


# Functions
from django.db.transaction import commit                 as transaction_commit   
from django.db.transaction import rollback               as transaction_rollback 

#from django.db.transaction import set_dirty              as transaction_set_dirty
def transaction_set_dirty(*args, **kwargs):
	return

# Decorators
#from django.db.transaction import commit_manually        as transaction_commit_manually       
#from django.db.transaction import commit_on_success      as transaction_commit_on_success    
#from django.db.transaction import commit_unless_managed  as transaction_commit_unless_managed


def fake_decorator(fun):

	def _fun(*args, **kwargs):
		return fun(*args, **kwargs)

	return _fun

transaction_commit_manually       = fake_decorator
transaction_commit_on_success     = fake_decorator
transaction_commit_unless_managed = fake_decorator
