
-- Fields types are defined in    sanet_common.sanetdef.constants.FIELD_TYPE_*

-- DATAGROUP
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'str'       , 'title');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'str'       , 'dependson');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'int'       , 'minperiod');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'int'       , 'shorttries');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'float'     , 'timeout');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'bool'      , 'deleted');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'bool'      , 'suspened');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'str'       , 'suspend_reason');         
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'timestamp' , 'suspend_time');           
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'timestamp' , 'suspend_resume_time');    
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'str'       , 'classification');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'str'       , 'passive_match');

INSERT INTO c_tfield (fclass, vtype, name) VALUES (1, 'str'       , 'scheduling_group');

-- DATASOURCE
INSERT INTO c_tfield (fclass, vtype, name) VALUES (2, 'str'  , 'title');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (2, 'str'  , 'expr');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (2, 'int'  , 'order');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (2, 'bool' , 'cascade');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (2, 'bool' , 'save_value');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (2, 'bool' , 'gauge');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (2, 'float', 'min_val');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (2, 'float', 'max_val');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (2, 'str'  , 'storage_spec');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (2, 'str'  , 'classification');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (2, 'bool' , 'deleted');                   

-- DATACONDITION
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'str'  , 'title');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'bool' , 'primary');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'str'  , 'dependson');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'str'  , 'expr');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'int'  , 'max_tries');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'int'  , 'uncheckable_fallback');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'str'  , 'statuschange_action');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'float', 'priority');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'str'  , 'classification');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'str'  , 'email');       
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'str'  , 'upemail');     
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'str'  , 'msg_downsubj');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'str'  , 'msg_downbody');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'str'  , 'msg_upsubj');  
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'str'  , 'msg_upbody');  
INSERT INTO c_tfield (fclass, vtype, name) VALUES (3, 'bool' , 'deleted');                   

-- TIMEGRAPH
INSERT INTO c_tfield (fclass, vtype, name) VALUES (4, 'str' , 'title');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (4, 'bool', 'primary');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (4, 'bool', 'stacked');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (4, 'str' , 'ylegend');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (4, 'bool', 'deleted');        
INSERT INTO c_tfield (fclass, vtype, name) VALUES (4, 'str' , 'classification'); 

-- TIMEGRAPH SERIE
INSERT INTO c_tfield (fclass, vtype, name) VALUES (5, 'str' , 'color');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (5, 'int' , 'render_order');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (5, 'str' , 'variable_value');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (5, 'str' , 'computed_value_expr');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (5, 'str' , 'legend');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (5, 'str' , 'style');
INSERT INTO c_tfield (fclass, vtype, name) VALUES (5, 'bool', 'deleted'); 





 

 




