#!/bin/bash

REDIS_TEMP_FILE=$(mktemp)

# Creat commands
echo "Creating temp file" $REDIS_TEMP_FILE

#echo "select 3" > $REDIS_TEMP_FILE
echo -e 'select 3\nkeys QUEUE_temp*' | redis-cli | grep -v '^$' | grep -v "OK"  > $REDIS_TEMP_FILE

if [[ ! -s "$REDIS_TEMP_FILE" ]]; then
	echo "file is empty"
	exit 0
fi

echo "select 3" > $REDIS_TEMP_FILE.new
cat $REDIS_TEMP_FILE | sed -e 's/^/del /' >> $REDIS_TEMP_FILE.new
mv $REDIS_TEMP_FILE.new $REDIS_TEMP_FILE


# Executing commands
cat $REDIS_TEMP_FILE | redis-cli > /dev/null
