
var log = {};

log.validate = function (data)
{
	//
	// FIX: questo metodo quando veiene chiamato?
	//
};

/*
function ISODateString(d){
    function pad(n){return n<10 ? '0'+n : n}
    return    
              d.getUTCFullYear()    + '-'
        + pad(d.getUTCMonth()   +1) + '-'
        + pad(d.getUTCDate()      ) + ' '
        + pad(d.getUTCHours()     ) + ':'
        + pad(d.getUTCMinutes()   ) + ':'
        + pad(d.getUTCSeconds()   );
}
*/



function prepareOptions(widget)
{
	var div = $(widget);

	var options = {};
	//var options_json = wcore.read.call(widget, "options");
	//var options_json = wcore.setWstate.call(ev.data.widget, {'search_string': ''});
	var options = wcore.getWstate.call(widget);
	
	//console.log("SAVED OPTIONS", options_json);
	//if (typeof(options_json) != "undefined")
	//	options = $.parseJSON(options_json);

	var pagesize = parseInt(div.find("select[name=pagesize]").val());
	if (options['pagesize'] != pagesize) {		
		options['pagesize'] = parseInt(div.find("select[name=pagesize]").val());
		options['page']     = 1;
	}
	
	options['priority']   = div.find("[name=priority]").val();
	options['freetext']   = div.find("[name=freetext]").val();
	options['date_start'] = div.find("[name=date_start]").val();
	options['date_end']   = div.find("[name=date_end]").val();
	options['hour_start'] = div.find("[name=hour_start]").val();
	options['hour_end']   = div.find("[name=hour_end]").val();

	wcore.setWstate.call(widget, options);
	
	return options;
}

log.refreshLog = function(ev) 
{
	ev.stopPropagation();

	var widget  = ev.data.widget;

	options = prepareOptions(widget);

	//lwp.warn.call(widget, "Loading data from server...");
	
	//console.log("OPTIONS FOR REMOTE: ", options);
	wcore.async.lock.call(widget);
	
	wcore.update.call(widget, options, true);
	
	
};

log.exportLog = function(ev) 
{
	var url      = ev.data.url;
	var etype    = ev.data.etype;
	var uuid     = ev.data.uuid;

	ev.stopPropagation();

	var widget  = ev.data.widget;

	options = prepareOptions(widget);

	$.ajax({
		url: url, 
		type: 'POST',
		data: {
			'etype'  : etype,
			'uuid'   : uuid,
			'options': JSON.stringify(options)
		},
		success: function(data) {
		}
	});
};

log.changeSort = function(ev)
{
	ev.stopPropagation();
	
	var widget  = ev.data.widget;
	
	var caller = $(this)

	options = prepareOptions(widget);

	//console.log("CURRENT SORT", options['sort_type'], options['sort_field']);
	//console.log("SORT FIELD", caller.attr('sortfield'));

	var sortfield  = caller.attr('sortfield').trim();
	
	if (sortfield == options['sort_field']) {
		options['sort_type'] = options['sort_type'] * -1;
	}
	else {
		options['sort_field'] = sortfield;
		options['sort_type' ] = 1;
	}

	//console.log("OPTIONS FOR REMOTE: ", options);
	
	wcore.setWstate.call(widget, options);
	
	//wcore.async.lock.call(widget);
	wcore.update.call(widget, options, true);
}


log.changePage = function(ev)
{
	ev.stopPropagation();
	
	var widget  = ev.data.widget;
	
	var caller = $(this)

	options = prepareOptions(widget);
	
	
	var selected_page = caller.text().trim();
	
	//console.log("CURRENT", options['page']);
	//console.log("SELECTED", selected_page);
	
	if      (selected_page == '<<') {
		selected_page = 1;
	}
	else if (selected_page == '<') {
		selected_page = options['page'] - 1;
	}
	else if (selected_page == '>') {
		selected_page = options['page'] + 1;
	}
	else if (selected_page == '>>') {
		selected_page = -1;
	}
	else {
		selected_page = parseInt(selected_page);
	}

	//console.log("SELECTED2", selected_page);

	options['page'] = selected_page;


	wcore.setWstate.call(widget, options);

	//console.log("OPTIONS FOR REMOTE: ", options);
	//wcore.async.lock.call(widget);
	wcore.update.call(widget, options, true);

	return false;
}

log.expandLog = function(ev)
{
	var widget = ev.data.widget;
	var url    = ev.data.url;
	var logid  = ev.data.logid;
	var type   = ev.data.type;


	//
	// Dobbiamo "espandere" dei blocchi. Meglio bloccare eventuali aggiornamenti
	//
	wcore.blockAutorefresh.call(widget);

	//
	// Se i dati sono gia' nella pagina li mostriamo, altrimenti li dobbiamo scaricare
	//
	
	var row_id         = logid;
	var row_details_id = logid + '_' + type;
	
	var row = $('#'+row_details_id);
	if (row.length != 0) {
		row.toggle();
		return;
	}


	url = url + '?uuid='+logid;
	
	$.ajax({
		type: 'POST',
		url: url,
		async: false,
		success: function(data){

			data = $.parseJSON(data)

			data['msg'] = data['msg'].replace(/\n/g, '<br>')

			var html_content = '<tr id="' + row_details_id +'"><td colspan="6"><tt>'+data['msg']+'</tt></td></tr>';
						
			var row = $(html_content);
			row.insertAfter('#'+row_id);
		}
	});
}

log.toggleVisibleEventType = function(ev)
{
	var widget = ev.data.widget;
	var kind   = ev.data.kind;

	//console.log("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX", ev.data);
	
	if (kind == "condition")
		kind = 1;
	else if (kind == "snmptrap")
		kind = 3;
	else if (kind == "custom")
		kind = 4;
	else
		return;

	options = prepareOptions(widget);

	//console.log("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX", options['selected_kinds'][kind]);
	
	options['selected_kinds'][kind] = ! options['selected_kinds'][kind];

	//console.log("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX UPDATE");

	wcore.setWstate.call(widget, options);

	//console.log("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX REFRESH", options);

	//console.log("OPTIONS FOR REMOTE: ", options);
	//wcore.async.lock.call(widget);
	wcore.update.call(widget, options, true);


}


function render_table(selected_transitions)
{
	var states = Array(
		'DN', 
		'FA', 
		'UD', 'UU', 
		'DD', 'DU', 
		//'TD', 'TU', 
		'IN', 
		'UP'
	);
	
	if (selected_transitions == undefined)
		selected_transitions = new Object();
	
	html = '';
	html += '<table name="transitions_table_panel" border="0" cellspacing=0 cellpadding=0>';
	html += '<tr>';
	html += '<td align="center">';
			
			html += '<table name="transitions_table" align="center" cellpadding="1" cellspacing="1" border=0>';

			// header
			html += '<tr>';
			html += '<td></td>';
			html += '<td style="background-color:#D7ECC7;" align="center" colspan="'+(states.length+2)+'"><b>' + gettext("To")   + '</b></td>';
			html += '</tr>';
			
			html += '<tr>';
			html += '<td style="background-color:#D7ECC7;" valign="middle" rowspan="'+(states.length+1)+'"><b>' + gettext("From") + '</b></td>';
			html += '<td></td>';
			for (c=0; c<states.length; c++) {
				html += '<td colselector" class="colselector" val="'+ states[c] +'">  <button  class="bg-'+states[c]+'"  >' + states[c] + '</button></td>';
			} 
			html += '</tr>';
			
			// rows
			for (r=0; r<states.length; r++) {
				
				var t_from = states[r];
				
				html += '<tr>';
				html += '<td valign="middle" align="center" class="rowselector" val="'+t_from+'"> <button class="bg-'+t_from+'" >' + t_from + '</button> </td>';
				
				for (c=0; c<states.length; c++) {
					
					var t_to   = states[c];
					
					//var t = states[r]+'-'+states[c];
					var checked = '';
					
					//if (selected_transitions[t] != undefined) checked = 'checked="checked"';
					if (selected_transitions[t_from] != undefined)
						if (selected_transitions[t_from][t_to] == 1) 
							checked = 'checked="checked"';
							
					if (r == c) cell = '';
					else        cell = "<input row='"+t_from+"' col='"+t_to+"' type='checkbox' name='transition' "+checked+" />";
					
					html += '<td  valign="middle" align="center" >'+cell+'</td>';
				}
				html += '</tr>';
			}
			html += '</table>';

			html += '<button name="reset_states">Reset</button>';
			
	html += '</td>';
	/*
	html += '<td>';
	html += '\
		<table class="log_legend"> \
			<tr> <th width="1"></th>        <th style="font-size: small">Description</th> </tr> \
			<tr> <td class="bg-DN">DN</td> <td style="font-size: small">Down</td>                   </tr> \
			<tr> <td class="bg-FA">FA</td> <td style="font-size: small">Failing</td>                </tr> \
			<tr> <td class="bg-UD">UD</td> <td style="font-size: small">Unchechable (DOWN)</td>     </tr> \
			<tr> <td class="bg-UU">UU</td> <td style="font-size: small">Uncheckable (UP)</td>       </tr> \
			<tr> <td class="bg-TD">TD</td> <td style="font-size: small">Out of Time (DOWN)</td>     </tr> \
			<tr> <td class="bg-TU">TU</td> <td style="font-size: small">Out of Time (UP)</td>       </tr> \
			<tr> <td class="bg-IN">IN</td> <td style="font-size: small">Suspended</td>              </tr> \
			<tr> <td class="bg-UP">UP</td> <td style="font-size: small">UP</td>                     </tr> \
		</table> \
		';
	html += '</td>';
	*/
	html += '</tr>';
	html += '</table>';

	return html;
}


log.wrender = function ()
{
	var widget = this;

	var display = wcore.getDisplay.call(widget);
	display.empty();



	var data    = wcore.read.call(this, 'data');
	
	console.log("DATA" + data);
	
	if (typeof(data) == 'undefined') {
		console.log('loading data from server...');
		display.append("<p>Loading logs from server...</p>");
		return;
	}

	var options = undefined;
	
	options =	wcore.getWstate.call(widget);
	if (options == undefined)
		options = data['options'];
	if (options == undefined)
		options = new Object();


	//console.log("LOG options:", options);
	
	wcore.setWstate.call(widget, options);

	




	
	//
	// Handle options
	//

	var WIDGET = this;

	data['timestamp_sort'] = 'icon-sort';
	data['priority_sort' ] = 'icon-sort';
	data['element_sort'  ] = 'icon-sort';
	data['condition_sort'] = 'icon-sort';
	
	var s = (options['sort_type'] == 1) ? 'up': 'down';
	if (options['sort_field'] == 'timestamp'     ) { data['timestamp_sort'] = 'icon-caret-'+ s; data['timestamp_sort_on'] = 1; }
	if (options['sort_field'] == 'priority'      ) { data['priority_sort' ] = 'icon-caret-'+ s; data['priority_sort_on' ] = 1; }
	if (options['sort_field'] == 'element_path'  ) { data['element_sort'  ] = 'icon-caret-'+ s; data['element_sort_on'  ] = 1; }
	if (options['sort_field'] == 'condition_path') { data['condition_sort'] = 'icon-caret-'+ s; data['condition_sort_on'] = 1; }


	//json_options = JSON.stringify(options);	
	//wcore.write.call(WIDGET, json_options, "options");


	//
	// RENDER
	//

	var pagesizes = [5, 10, 25, 50, 100];
	data['pagesizes'] = new Array();
	for (var i=0; i< pagesizes.length; i++) {
		data['pagesizes'][i] = {'val':pagesizes[i], 'selected': pagesizes[i] == options['pagesize'] };
	}

	//console.log("pagesizes: ", data['pagesizes']);

	var num_pages = 16;

	data['pages'] = new Array();
	for (var p=1; p <= num_pages; p++) 
		data['pages'][p-1] = {'num':p, 'selected': options['page'] == p };

	EVENT_CONDITION    = 1
	EVENT_SYSLOG       = 2
	EVENT_SNMPTRAP     = 3
	EVENT_CUSTOM       = 4

	if (data['logs'] != undefined) {

		for (var i=0; i < data['logs'].length; i++) {
			l = data['logs'][i];
			
			if (l['k'] == EVENT_CONDITION) {
				l['is_condition'] = 1;
			}
			else {
				l['is_condition'] = 0;
				l['cur']  = '';
				l['prev'] = '';
			}
			
			console.log(l['msg']);
		}
	}
	
		
	

	//console.log("SHOW BUTTON", data['selected_kinds']);

	if (options['selected_kinds'] != undefined) {
		if (options['selected_kinds'][EVENT_CONDITION] == true) data['selected_conditions'   ]  = 1;
		if (options['selected_kinds'][EVENT_SNMPTRAP]  == true) data['selected_snmptraps'    ]  = 1;
		if (options['selected_kinds'][EVENT_CUSTOM]    == true) data['selected_customevents' ]  = 1;
	}

	var CONTENT_TEMPLATE = '\
	<div> \
		<span style="font-size: 1.5em; font-weight:bold">Log:</span>  \
		<img class="icon16x16" src="{{ icon_url }}">\
		{{ element_path }} \
	<div> \
	<br /> \
	<table border=0 style="border-collapse:collapse" width=100%> \
	<tr> \
		<td valign="top"> \
			{{#options}} \
			<table width=100% border=0> \
			<tr>\
			<td>\
						<span> \
							<nobr> \
								<button class="show_event_kind" kind="condition" title="Conditions"    {{^selected_conditions}}  style="background-color:red;"{{/selected_conditions}}   > C </button>\
								<button class="show_event_kind" kind="snmptrap"  title="Traps"         {{^selected_snmptraps}}   style="background-color:red;"{{/selected_snmptraps}}    > T </button>\
								<button class="show_event_kind" kind="custom"    title="Custom Events" {{^selected_customevents}}style="background-color:red;"{{/selected_customevents}} > E </button>\
						</span> \
						\
						<span> \
							<nobr> \
							<b>Testo: </b> \
							<input name="freetext"                             size="50" value="{{freetext}}"   type="text" > \
							</nobr> \
						</span> \
						        \
						<span> \
							<nobr> \
							<b>Da :          </b> \
							<input name="date_start"     class="vDateFieldISO" size="8"  value="{{date_start}}" type="text"> \
							<input name="hour_start"     class=""              size="7"  value="{{hour_start}}" type="time ">   \
							<b>A  :          </b> \
							<input name="date_end"       class="vDateFieldISO" size="8"  value="{{date_end}}"   type="text">  \
							<input name="hour_end"       class=""              size="7"  value="{{hour_end}}"   type="time ">  \
							</nobr> \
						</span> \
						\
						<span> \
							<nobr> \
							<b>Priorita:     </b> \
							<input name="priority"                             size="3"  max=100 min=1 maxlength=3 value="{{priority}}"   type="text"> \
							</nobr> \
						</span> \
						\
						<span> \
							<nobr> \
								<b>Transizioni: </b> \
								\
								<button name="default_transitions"> \
									<span style="font-weight: bold; color: green">UP</span> \
									>  \
									<span style="font-weight: bold; color: #ffdd00">FA</span> \
									>  \
									<span style="font-weight: bold; color: red">DN</span>  \
								</button> \
								\
								<button name="show_transition_table"> <li class="icon-table"></li> Select </button>          \
								\
								<div name="transitions_panel"> \
								</div> \
							</nobr> \
						</span> \
			</td> \
			</tr> \
			</table> \
			{{/options}} \
		</td> \
		<td align=left valign=top> \
				<select id="pagesize" name="pagesize"> \
					{{#pagesizes}} \
						<option value="{{val}}"  {{#selected}}selected="selected"{{/selected}}> {{val}} </option>  \
					{{/pagesizes}} \
				</select> \
		</td> \
		<td align=left valign=top> \
				<button title="Cerca/Aggiorna"  id="refreshbutton"  name="refreshbutton"  > \
					<li class="icon-refresh"    style="font-size: 16px;" /> \
				</button> \
		</td> \
		<td width=1align=right valign="top"> \
				<button title="Esporta" name="exportbutton"> \
					<li class="icon-file-text"  style="font-size: 16px;" /> \
				</button> \
		</td> \
	</tr> \
	</table> \
	<!-- \
	<table border=0 style="border-collapse:collapse" width=100%> \
	<tr name="log_search_options"> \
		<td style="background-color: #e0e0e0" colspan=2> \
			{{#options}} \
			<table border=0 cellspacing=0 cellpadding=0> \
				<tr> \
					<td> \
						<b>Testo: </b> \
						<input name="freetext"                             size="50" value="{{freetext}}"   type="text" \
						        \
						> \
					</td> \
				</tr> \
				<tr> \
					<td> \
					</td> \
				</tr> \
				<tr> \
					<td> \
						<b>Da :          </b> \
						<input name="date_start"     class="vDateFieldISO" size="8"  value="{{date_start}}" type="text"> \
						<input name="hour_start"     class=""              size="7"  value="{{hour_start}}" type="time ">   \
						<b>A  :          </b> \
						<input name="date_end"       class="vDateFieldISO" size="8"  value="{{date_end}}"   type="text">  \
						<input name="hour_end"       class=""              size="7"  value="{{hour_end}}"   type="time ">  \
					</td> \
				</tr> \
				<tr> \
					<td valign="top">  \
						<b>Priorita:     </b> \
						<input name="priority"                             size="3"  max=100 min=1 maxlength=3 value="{{priority}}"   type="text"> \
						<b>Transizioni: </b> \
						<button name="show_transition_table"> <li class="icon-table"></li> </button>          \
						<div name="transitions_panel"> \
						</div> \
					</td> \
				</tr> \
			</table> \
			{{/options}} \
		</td> \
	</tr> \
	</table> \
	--> \
	<table style="border-collapse:collapse" width=100%> \
	<tr> \
		<td width="60%"  align="center"> \
			<button class="selectpage" href=""> \
				&lt;&lt; \
			</button> \
			\
			<button class="selectpage"  href=""> \
				&lt; \
			</button> \
			 \
			<!-- {{#pages}} \
				{{#selected}} \
					<button class="selectpage"  style="background-color:#3333ff; ">{{num}}</button>  \
				{{/selected}} \
				{{^selected}} \
					<button class="selectpage"  href="" ">{{num}}</button>  \
				{{/selected}} \
			{{/pages}} -->\
			 \
			<button class="selectpage"  href=""> \
				&gt; \
			</button> \
			\
			<!-- <button class="selectpage"  href=""> \
				&gt;&gt; \
			</button> --> \
		</td> \
	</tr> \
	</table> \
	\
	<table class="gui-table" border="1" width="100%" >\
		<tr class="gui-tr" > \
			<!-- <th class="gui-th" width=1> \
										<button> \
											<li class="icon-check"       style="font-size: 12px;" /> \
										</button> \
			</th> --> \
			<th class="gui-th" width=1> \
				T \
			</th> \
			<th class="gui-th" width=1> \
						<span  class="sortcolumn" sortfield="timestamp">  \
									<nobr> Time      <li class="{{timestamp_sort}}"    style="font-size: 12px; {{#timestamp_sort_on}}color:#00ff00;{{/timestamp_sort_on}}" /> </nobr>\
						</span> \
			</th> \
			<th class="gui-th" width=1>  \
						<span  class="sortcolumn" sortfield="priority" > \
									<nobr> P         <li class="{{priority_sort}}"     style="font-size: 12px; {{#priority_sort_on}}color:#00ff00;{{/priority_sort_on}}" /> </nobr>              \
						</span>\
			</th> \
			<th class="gui-th" width=1>  \
						<span  class="sortcolumn" sortfield="element_path" > \
									<nobr> Element   <li class="{{element_sort}}"      style="font-size: 12px; {{#element_sort_on}}color:#00ff00;{{/element_sort_on}}" /> </nobr>              \
						</span>\
			</th>                        \
			<th class="gui-th">  \
						<span  class="sortcolumn" sortfield="condition_path" > \
									<nobr> Logged entity <li class="{{condition_sort}}"    style="font-size: 12px; {{#condition_sort_on}}color:#00ff00;{{/condition_sort_on}}" /> </nobr>              \
						</span>\
			</th> \
			<th class="gui-th" width=1>  \
									Change      \
			</th>                        \
			<th class="gui-th" width=1>  \
			</th> \
		</tr> \
		{{#init}} \
		<tr> \
			<td align="center" colspan="7"> \
				<p> \
					Loading data from server....  \
				</p> \
			</td>\
		</tr> \
		{{/init}} \
		{{^init}} \
			\
			{{#logs}} \
			<tr id="{{id}}"    class="gui-tr bg-{{cur}} logrow"  val="{{id}}" style="padding:0px; spacing:0px;"> \
				\
				<!-- <td> <input id="{{uuid}}" type="checkbox" />  </td> --> \
				\
				<td> \
					{{#logkind2str}}{{k}}{{/logkind2str}} \
				</td> \
				<td> \
					<nobr style="font-size:.8em">{{ts}}</nobr> \
				</td> \
				<td align="right">\
					{{#p}}{{p}}{{/p}}\
				</td> \
				<td> \
					<nobr> \
					<a href="{{url_path}}?path={{element}}">{{element}}</a> \
				</td> \
				<td> \
					<nobr> \
					{{#is_condition}} \
					<a href="{{url_path}}?path={{cpath}}"> \
						{{cpath}} \
					</a> \
					{{/is_condition}} \
					{{^is_condition}} \
						{{cpath}} \
					{{/is_condition}} \
				</td> \
				<td> \
					{{prev}}-{{cur}} \
				</td> \
				<td> \
					<nobr> \
					<div class="gui-button gui-gradient expandlog"      val="{{id}}" style="cursor:pointer; padding: 0px; padding-right: 4px; padding-left : 4px;" > <i class="icon-chevron-sign-down   icon16x16" > </i> </div> \
					{{#is_condition}} \
					<div class="gui-button gui-gradient expandentables" val="{{id}}" style="cursor:pointer; padding: 0px; padding-right: 4px; padding-left : 4px;" > <i class="icon-envelope   icon16x16" >          </i> </div> \
					{{/is_condition}} \
				</td> \
			</tr> \
			{{/logs}}	 \
			{{^logs}}	 \
			<tr> \
				<td colspan="6"> \
					<center style="font-size: 24px; color: orange"> \
						No data \
					</center> \
				</td> \
			</tr> \
			{{/logs}} \
		\
		{{/init}} \
		\
	</table> \
	';

	data['logkind2str'] = function () {
		return function (text, render) {
			var k = parseInt(render(text));
			if      (k == 1) return "C";
			else if (k == 3) return "T";
			else if (k == 4) return "E";
			else             return text;
		}
	};
	
	/*
	data['timestamp2iso'] = function () {
		return function (text, render) {
			return (ISODateString(new Date(parseInt(render(text)*1000))));
		}
	};
	*/
	

	var html_content = Mustache.to_html(CONTENT_TEMPLATE, data)	
	display.append( $(html_content) );

	if (data['init'] != undefined) {
		wcore.async.lock.call(widget);
	}

	//
	// BIND EVENTI
	//
	display.find('.show_event_kind').each( function(i) {
		$(this).bind('click', { widget:widget, kind:$(this).attr('kind') }, log.toggleVisibleEventType );
	});


	
	display.find('[name=freetext]').each( function(i) {
		$(this).bind('keyup', {widget:widget}, function(ev) {
			if (ev.keyCode == 13) {
				var button = display.find('[name=refreshbutton]')
				button.click();
			}
		});
	});
	display.find('[name=priority]').each( function(i) {
		$(this).bind('keyup', {widget:widget}, function(ev) {
			if (ev.keyCode == 13) {
				var button = display.find('[name=refreshbutton]')
				button.click();
			}
		});
	});

	
	display.find('.selectpage').each( function(i) { 
		$(this).bind('click', {widget:WIDGET}, log.changePage);
	});

	display.find('.sortcolumn').each( function(i) { 
		$(this).bind('click', {widget:WIDGET}, log.changeSort);
	});

	display.find('.expandlog').each( function(i) { 
		$(this).bind('click', {widget:WIDGET, url: data['url'], logid:$(this).attr('val'), type:"details"}, log.expandLog );  
	});

	display.find('.expandentables').each( function(i) { 
		$(this).bind('click', {widget:WIDGET, url: data['url_entables'], logid:$(this).attr('val'), type:"entables"}, log.expandLog );  
	});


	var button = display.find('[name=refreshbutton]')
	button.bind('click', {widget: WIDGET}, log.refreshLog)


	var button = display.find('[name=exportbutton]')
	button.bind('click', {widget: WIDGET, url: data['exporturl'], etype: data['etype'], uuid: data['uuid'] }, function (ev) {
		//
		// FIX: facciamo una GET con tutti i parametri perche' non ho trovato un modo per fare una POST in un'altra finestra del browser
		//
		var base_url = data['exporturl'] + '?' + 'uuid='+data['uuid'] + '&' + 'etype='+data['etype']+ '&' + 'options=' + JSON.stringify(options);
		window.location = base_url;
	})

	var option_panel = display.find('[name=log_search_options]');

	//if (! options['show_options']) 
	//	option_panel.css('display', 'none');

	display.find('[name=button_show_search]').each( function(i) { 
		$(this).bind('click', {widget:WIDGET}, function(ev) { 

			display.find('[name=log_search_options]').toggle();

			var widget  = ev.data.widget;
			options = prepareOptions(widget);
			
			
			options['show_options'] = display.find('[name=log_search_options]').is(":visible");

			//json_options = JSON.stringify(options);	
			//wcore.write.call(widget, json_options, "options");
			wcore.setWstate.call(widget, options);
		} );
	});	
	
	//
	// Fil transitions
	//
	
	
	var transitions_panel = display.find('[name=transitions_panel]');
	var table = render_table(options['transitions']);
	transitions_panel.append(table);

	display.find('[name=transition]').each( function(i) { 
		$(this).bind('click', {widget:WIDGET}, function(ev) { 

			var t_from = $(this).attr("row");
			var t_to   = $(this).attr("col");
			
			var widget  = ev.data.widget;
			options = prepareOptions(widget);
			
			if (options['transitions'] == undefined)
				options['transitions'] = new Object();
			
			if (options['transitions'][t_from] == undefined)
				options['transitions'][t_from] = new Object();
				
			options['transitions'][t_from][t_to] =  $(this).is(':checked') ? 1 : 0;

			wcore.setWstate.call(widget, options);
		});
	});
	
	display.find('[name=default_transitions]').each( function(i) { 
		$(this).bind('click', {widget:WIDGET}, function(ev) { 
			var widget  = ev.data.widget;
			options = prepareOptions(widget);
			options['transitions'] = { UP: { FA: 1, DN: 1} , FA: { UP:1, DN: 1 }, DN: { UP: 1 } };
			wcore.setWstate.call(widget, options);
			
			display.find('[name=refreshbutton]').click();
		});
	});
	

	display.find('[name=reset_states]').each( function(i) { 
		$(this).bind('click', {widget:WIDGET}, function(ev) { 

			var widget  = ev.data.widget;
			options = prepareOptions(widget);

			display.find('[name=transition]').each( function(i) {
				$(this).attr('checked', false);
				
				var t_from = $(this).attr("row");
				var t_to   = $(this).attr("col");
				
				if (options['transitions'] == undefined)
					options['transitions'] = new Object();
				
				if (options['transitions'][t_from] == undefined)
					options['transitions'][t_from] = new Object();
					
				options['transitions'][t_from][t_to] =  0;
			});


			//json_options = JSON.stringify(options);	
			//wcore.write.call(widget, json_options, "options");

			wcore.setWstate.call(widget, options);

			
		});
	});
	


	display.find('.colselector').each(function(i){
		
		$(this).bind('click', {widget:WIDGET}, function(ev) { 
			
			var widget  = ev.data.widget;
			options = prepareOptions(widget);
			
			var col = $(this).attr('val');

			display.find('[col='+col+']').each( function(i) {
				$(this).attr('checked', ! $(this).attr('checked'));
				
				var v = $(this).attr('checked');
				
				var t_from = $(this).attr("row");
				var t_to   = $(this).attr("col");
				
				if (options['transitions'] == undefined)
					options['transitions'] = new Object();
				
				if (options['transitions'][t_from] == undefined)
					options['transitions'][t_from] = new Object();
					
				options['transitions'][t_from][t_to] =  v ? 1:0 ;
			});			
			
			//json_options = JSON.stringify(options);	
			//wcore.write.call(widget, json_options, "options");
			
			wcore.setWstate.call(widget, options);
		});
	});

	display.find('input').focus({widget:WIDGET}, function(e) {
		
		var widget = e.data.widget;
		wcore.blockAutorefresh.call(widget);
	});


	display.find('.rowselector').each(function(i){
		
		$(this).bind('click', {widget:WIDGET}, function(ev) { 
			
			var widget  = ev.data.widget;
			options = prepareOptions(widget);
			
			var row = $(this).attr('val');

			display.find('[row='+row+']').each( function(i) {
				$(this).attr('checked', ! $(this).attr('checked'));
				
				var v = $(this).attr('checked');
				
				var t_from = $(this).attr("row");
				var t_to   = $(this).attr("col");
				
				if (options['transitions'] == undefined)
					options['transitions'] = new Object();
				
				if (options['transitions'][t_from] == undefined)
					options['transitions'][t_from] = new Object();
					
				options['transitions'][t_from][t_to] =  v ? 1:0 ;
			});			
			
			//json_options = JSON.stringify(options);	
			//wcore.write.call(widget, json_options, "options");
			
			wcore.setWstate.call(widget, options);
			
		});
	});	

	
	
	display.find('[name=show_transition_table]').each(function(i){
		$(this).bind('click', {widget:WIDGET}, function(ev) { 

			var widget  = ev.data.widget;

			display.find('[name=transitions_table_panel]').toggle();
			
			// Mostriamo il pannello
			visible = display.find('[name=transitions_table_panel]').is(":visible");

			if (visible)
				// Se il pannello e' visibile blocchiamo il refresh
				wcore.blockAutorefresh.call(widget);


			
			options = prepareOptions(widget);
			options['show_transitions_table'] = visible;

			wcore.setWstate.call(widget, options);
			
		});
	});

	if (! options['show_transitions_table']) 
		display.find('[name=transitions_table_panel]').css('display', 'none');


	//display.find('[name=hour_start]').each(function(i) {
	//		$(this).timepicker({ 'timeFormat': 'h:i A' });
	//});
};





WDS.wlib['log'] = log;
