

def lighten_rgb( c, factor=0.95):
	
    # no color for element
    if not c:
        return "000000"

    r = int(c[0:2], 16)
    g = int(c[2:4], 16)
    b = int(c[4:6], 16)

    cmax = max(r,g,b) / 255.0  # luminosita'
    cmax = cmax * factor

    cmax *= 255

    r = int(min(255, r + cmax))
    g = int(min(255, g + cmax))
    b = int(min(255, b + cmax))

    return ''.join([('%2x'%(v)).replace(' ','0') for v in (r,g, b)])
