
from cli.prompts import cli_register_menu, cli_register_hook

from webui.cli.prompts.show     import tenant_show_settings
from webui.cli.prompts.show     import tenant_show_configuration_web_settings

from webui.cli.prompts.config   import menu_config_web_settings
from webui.cli.prompts.config   import menu_config_no_web_settings

def register_cli_hooks():
	
	# tenant ...
	#     <command>
	# exit
	cli_register_menu('configuration:tenant'    , 'web_settings'   , menu_config_web_settings)

	# tenant ..
	#     no <command>
	# exit
	cli_register_menu('configuration:tenant:no' , 'web_settings'   , menu_config_no_web_settings)

	#
	# Show hooks
	#

	# show tenant ...
	cli_register_hook('show:tenant', 'web_settings'   , tenant_show_settings)

	#
	# show conf hooks
	#
	cli_register_hook('show:tenant:configuration'    , 'web_settings', tenant_show_configuration_web_settings)

	return
